#line 1 "C:/Users/Carl/Documents/Pic Projects/Pic18/PIC Clicker IrThermo Click/PIC Clicker IrThermo Click.c"
#line 25 "C:/Users/Carl/Documents/Pic Projects/Pic18/PIC Clicker IrThermo Click/PIC Clicker IrThermo Click.c"
unsigned char readbuff[64] absolute 0x500;
unsigned char writebuff[64] absolute 0x540;

char kk;
char i;

float Temp;


sbit LD1 at LATA0_bit;
sbit LD2 at LATA1_bit;
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;

sbit T1 at RD3_bit;
sbit T2 at RD2_bit;
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;

const _IR_THERMO_ADDR = 0x5A;
const _AMB_TEMP = 0x06;
const _OBJ_TEMP = 0x07;
char txt[10];



void interrupt() {

 USB_Interrupt_Proc();
}

void clear_USB_buffers()
{
 for (i=0; i<63;i++)
 {
 readbuff[i] = 0;
 writebuff[i] = 0;
 }
}

char read_button1() {
 if (Button(&PORTD, 3, 2, 0)) {
 return 1;
 } else return 0;
}

char read_button2() {
 if (Button(&PORTD, 2, 2, 0)) {
 return 2;
 } else return 0;
}
#line 84 "C:/Users/Carl/Documents/Pic Projects/Pic18/PIC Clicker IrThermo Click/PIC Clicker IrThermo Click.c"
float ReadSensor(char Temp_Source){
 unsigned int Temp_var;

 I2C2_Start();
 I2C2_Wr(_IR_THERMO_ADDR << 1);
 I2C2_Wr(Temp_Source);
 I2C2_Repeated_Start();
 I2C2_Wr(_IR_THERMO_ADDR << 1);
 Temp_var = I2C2_Rd(0);
 Temp_var = (I2C2_Rd(0) << 8) + Temp_var;
 I2C2_Stop();

 return Temp_var;
}

void load_AMB() {

 for (i =0;i <10;i++) {
 writebuff[1+i]= txt[i];
 }
}

void load_OBJ() {

 for (i =0;i <10;i++) {
 writebuff[11+i]= txt[i];
 }
}

void main(){
 long cnt = 0;

 ANCON0 = 0xFF;
 ANCON1 = 0x1F;
 TRISD = 0;
 TRISB = 0;
 TRISA = 0;
 RCSTA1 = 1;


 T1_Direction = 1;
 T2_Direction = 1;

 LD1_Direction = 0;
 LD2_Direction = 0;
 LD1 = 0;
 LD2 = 0;

 I2C2_Init(50000);
 Delay_ms(1000);


 clear_USB_buffers();
 HID_Enable(&readbuff,&writebuff);


 while (1){

 kk = HID_Read();
 if (kk != 0)
 {

 Temp = ReadSensor(_AMB_TEMP);
 Temp = (Temp * 0.02) - 273.15;
 FloatToStr(Temp, txt);
 load_AMB();

 Temp = ReadSensor(_OBJ_TEMP);
 Temp = (Temp * 0.02) - 273.15;
 FloatToStr(Temp, txt);
 load_OBJ();

 if ((readbuff[0] & 0x01 )> 0) {
 LD1 = 1;
 } else LD1 = 0;
 if ((readbuff[0] & 0x02 )> 0) {
 LD2 = 1;
 } else LD2 = 0;

 writebuff[0]=0;
 writebuff[0] = writebuff[0] | read_button1() ;
 writebuff[0] = writebuff[0] | read_button2() ;

 HID_Write(&writebuff,64);
 }
 }
}
